﻿#targetengine "Endnotesfromtext";

// EndnotesFromTags.jsx
//An InDesign CС2022 JavaScript
//
/*
Скрипт предназначен для восстановления концевых сносок, помеченных в тексте тэгами.
Особенность скрипта в том, что он сохраняет локальное форматирование сносок Bold, Italic, Bold Italic и др.
Скрипт подразумевает, что преобразование сносок в тэгированный текст 
выполнено в MS Word макросом endnotesToText .
Mакрос для MS Word приведен в конце этого скрипта. Кадая концевая сноска заключена
в тэги "<EndnoteStart:>" и "<EndnoteEnd:>"

Скрипт очень не любит пустые сноски, когда в тексте стоит "<EndnoteStart:><EndnoteEnd:>"
Если уж вам так у нужны эти пустые сноски, поставьте хотя бы пробел между тэгами начала и конца,
в противном случае удалите.
Скрипт предназначен для последних версий Индизайна, полагая, что в таблицах могут быть сноски, 
(с) Борис Кащеев, www.adobeindesign.ru, boriskasmoscow@gmail.com
Благодарности:
1) Kasyan Servetsky (в facebook) - за объяснение как программировать концевые сноски 
2) Иванюшину М. - за прогрессбар.


*/

var ProgressBar = function(title) {
var w = new Window('palette', title, {x:0, y:0, width:840, height:60},{closeButton: false}),
pb = w.add('progressbar', {x:20, y:34, width:800, height:12}),
st = w.add('statictext', {x:20, y:10, width:800, height:20});
st.justify = 'left';
w.center();

    this.reset = function(msg,maxValue) {
        st.text = msg;
        pb.value = 0;
        pb.maxvalue = maxValue;
        w.show();
        w.update();
    }
    this.info = function(msg) {
          st.text = msg;
          w.show();
          w.update();
    }
this.hit = function() {++pb.value; w.update();}
this.hide = function() {w.hide();}
this.close = function() {w.close();}
} // ProgressBar

var pBar;

var myProgramName = "Endnotes from Tags";
// ---------------------->Splash окно 
        var spl= new Window ("palette",undefined,undefined, {borderless: true});
            try {
                    var Splash = File (app.activeScript.path + "/a_splash.png");
                    var pict =spl.add ("image", undefined, File (Splash));
                    }
            catch(_) {
                   spl.graphics.backgroundColor = spl.graphics.newBrush (spl.graphics.BrushType.SOLID_COLOR, [0.5, 0.0, 0.5]);
                   var t1 = spl.add( "statictext",undefined,'<— Script EndNotes From Tag —>');
                    t1.graphics.font = ScriptUI.newFont ("Tahoma", "Bold", 30);
                    var t2 = spl.add( "statictext",undefined,'Version 1.0');
                    t2.graphics.font = ScriptUI.newFont ("dialog", "Bold", 12);
                    var t3 = spl.add( "statictext",undefined,'© Boris Kas');
                    t3.graphics.font = ScriptUI.newFont ("dialog", 10);
            }
        spl.show ();
        $.sleep(4000);
        spl.close()



var IndesignVersion = parseInt(app.version);

// Концевые сноски появились в Индизайне СС 2018, это был выпуск №13. Поэтому всё, что было до версии 13, обрубаем.
if ( IndesignVersion < 13)
    { alert("Ваша версия Индизайна не поддерживает концевые сноски", myProgramName);}
else
    app.doScript(
                main,                                      // The script to execute. Can accept: File, String or JavaScript Function.
                ScriptLanguage.JAVASCRIPT,   // The language of the script to execute.
                [],                                        // An array of arguments passed to the function 
                UndoModes.ENTIRE_SCRIPT, // How to undo this script.UndoModes.ENTIRE_SCRIPT
                'Script EndnotesFromTags'   // The name of the undo step for script undo mode. 
            ); 
exit();



//main();
function main()
{
        var myDoc = app.documents[0]; 

        var resultat = proverka(myDoc);
        if(resultat)    { footnotesFromTags(myDoc); }
        else exit();

	} // main()
//******************************************************************************************************
//                                       ОСНОВНАЯ ФУНКЦИЯ
//******************************************************************************************************
function footnotesFromTags(myDocument)
{
//---------строка для поиска тэгов в тексте-----------------------------	
	var myFindWhatStr = "(?<=<EndnoteStart:>)((.*\\r)*?).*?(?=<EndnoteEnd:>)";
// --------поиск коллекции тэгированных сносок -------------	
	resetGrepFind();
	app.findGrepPreferences.findWhat = myFindWhatStr;
	var myFoundItems = myDocument.findGrep();
    
// ------- Если сноски не найдены, то заканчиваем работу
    if(myFoundItems.length == 0) 
    {
        alert("Тэгированные концевые сноски в этом документе не найдены", myProgramName);
        exit();
    }
    alert("Найдено тэгированных концевых сносок для восстановления " + myFoundItems.length, myProgramName);

// --------процесс преобразования сносок и вставки их в текст --------

// --------------Progressbar------------------------------------
    var myDateF = new Date;
    var myHourF = myDateF.getHours();
    if (myHourF <10) myHourF = "0" + myHourF;
    var myMinuteF = myDateF.getMinutes();
    if (myMinuteF <10) myMinuteF = "0" + myMinuteF;   
    pBar = new ProgressBar(myProgramName);
    pBar.reset("Время начала обработки [ч:м] " + myHourF + ":"  + myMinuteF, myFoundItems.length); 
// ----------------------------------------------------------------
	var myEndnote;
	var counter = 0;

    // Основной цикл
	for(var i = myFoundItems.length-1; i >= 0; i--, pBar.hit())
	{
        pBar.info("Сейчас восстанавливается: " + (i+1) +" endnote, всего их было найдено " +myFoundItems.length);
        found = myFoundItems[i];
        if(found.contents == "") continue; // Пропускаем пустую сноску
        var taggedText = found.contents;
        myEndnote = found.insertionPoints[0].createEndnote();
        var endnoteTextRange = myEndnote.endnoteTextRange;
        var story = endnoteTextRange.parent;
        var storyOffset = story.insertionPoints[endnoteTextRange.endnoteRangeEndIndex - 1];
        var contents = taggedText;
        myEndnote.insertTextInEndnote(storyOffset, contents);
        found.remove();
        
		counter++
	} // for

// Удаление тэгов
    resetGrepFind();
    app.findGrepPreferences.findWhat = "<EndnoteStart:>|<EndnoteEnd:>";
    app.changeGrepPreferences.changeTo = "";
    myDocument.changeGrep();

// ---------------Результаты работы------------------
	if(counter == myFoundItems.length)
	{
		alert("Все концевые сноски успешно восстановлены, " +counter +" шт.",  myProgramName)
	}
	else{
	alert("Восстановлено сносок "+counter +" из "+myFoundItems.length+"\rНевосстановленных сносок " + myFoundItems.length - counter, myProgramName );
	}
// Конец
} // footnotesFromTags() 

function resetGrepFind()
{
	app.changeGrepPreferences = NothingEnum.nothing;
	app.findGrepPreferences = NothingEnum.nothing;
	app.findChangeGrepOptions.includeFootnotes = false;
	app.findChangeGrepOptions.includeHiddenLayers = false;
	app.findChangeGrepOptions.includeLockedLayersForFind = false;
	app.findChangeGrepOptions.includeLockedStoriesForFind = false;
	app.findChangeGrepOptions.includeMasterPages = false;
}


function proverka(myDocument)
{
 // Проверка на наличие пустых сносок
var pagesForEndnotes = [];
    resetGrepFind();
    var myFindWhatStr = "<EndnoteStart:><EndnoteEnd:>";
    app.findGrepPreferences.findWhat  = myFindWhatStr;
    var myFoundItems = myDocument.findGrep();
    if(myFoundItems.length > 0) {
        for(var i=0; i < myFoundItems.length; i++) {
            pagesForEndnotes[i] = myFoundItems[i].parentTextFrames[0].parentPage.name;
        }
        alert("На странице(ах) "+ pagesForEndnotes + " есть пустые сноски. Устраните их и запустите скрипт снова", myProgramName);
        return false;
    }   // if
    else return true;
} // fnc

/*
Макрос для MS Word по преобразованию сносок в текст с сохранением локального форматирования (эта строка не принадлежит макросу)

Sub EndnotesToText()
' Endnotes to text
Dim actdoc As Document
Dim en As Word.Endnote
Dim rngEN As Word.Range
Dim i As Long
Set actdoc = ActiveDocument

For i = actdoc.Endnotes.Count To 1 Step -1
  Set en = actdoc.Endnotes(i)  '
  Set rngEN = en.Reference  '
  rngEN.Collapse wdCollapseEnd  '
  rngEN.FormattedText = en.Range.FormattedText
  rngEN.InsertBefore Text:="<EndnoteStart:>"
  rngEN.InsertAfter Text:="<EndnoteEnd:>"
  en.Delete '
Next i
End Sub
*/ // конец макроса

/*
    
Kasyan Servetsky
Assuming you placed the cursor into the text where you want the endnote reference to appear (insertionPoint is selected):
main();
function main() {
var insertionPoint = app.selection[0];
var endnote = insertionPoint.createEndnote();
var endnoteTextRange = endnote.endnoteTextRange;
var story = endnoteTextRange.parent;
var storyOffset = story.insertionPoints[endnoteTextRange.endnoteRangeEndIndex - 1];
var contents = "Blah-blah-blah";
endnote.insertTextInEndnote(storyOffset, contents);
}
=======================================
*/


